All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends Pages
CustomManyParticleForce Class Reference

This class supports a wide variety of nonbonded N-particle interactions, where N is user specified. More...

`#include <CustomManyParticleForce.h>`

Inheritance diagram for CustomManyParticleForce:

## Public Types

enum | NonbondedMethod { NoCutoff = 0, CutoffNonPeriodic = 1, CutoffPeriodic = 2 }
| This is an enumeration of the different methods that may be used for handling long range nonbonded forces. More...
enum | PermutationMode { SinglePermutation = 0, UniqueCentralParticle = 1 }
| This is an enumeration of the different modes for selecting which permutations of a set of particles to evaluate the interaction for. More...

## Public Member Functions

| CustomManyParticleForce (int particlesPerSet, const std::string &energy)
| Create a CustomManyParticleForce. More...
| ~CustomManyParticleForce ()
int | getNumParticlesPerSet () const
| Get the number of particles in each set for which the energy is evaluated. More...
int | getNumParticles () const
| Get the number of particles for which force field parameters have been defined. More...
int | getNumExclusions () const
| Get the number of particle pairs whose interactions should be excluded. More...
int | getNumPerParticleParameters () const
| Get the number of per-particle parameters that the interaction depends on. More...
int | getNumGlobalParameters () const
| Get the number of global parameters that the interaction depends on. More...
int | getNumTabulatedFunctions () const
| Get the number of tabulated functions that have been defined. More...
const std::string & | getEnergyFunction () const
| Get the algebraic expression that gives the interaction energy of each bond. More...
void | setEnergyFunction (const std::string &energy)
| Set the algebraic expression that gives the interaction energy of each bond. More...
NonbondedMethod | getNonbondedMethod () const
| Get the method used for handling long range nonbonded interactions. More...
void | setNonbondedMethod (NonbondedMethod method)
| Set the method used for handling long range nonbonded interactions. More...
PermutationMode | getPermutationMode () const
| Get the mode that selects which permutations of a set of particles to evaluate the interaction for. More...
void | setPermutationMode (PermutationMode mode)
| Set the mode that selects which permutations of a set of particles to evaluate the interaction for. More...
double | getCutoffDistance () const
| Get the cutoff distance (in nm) being used for nonbonded interactions. More...
void | setCutoffDistance (double distance)
| Set the cutoff distance (in nm) being used for nonbonded interactions. More...
int | addPerParticleParameter (const std::string &name)
| Add a new per-particle parameter that the interaction may depend on. More...
const std::string & | getPerParticleParameterName (int index) const
| Get the name of a per-particle parameter. More...
void | setPerParticleParameterName (int index, const std::string &name)
| Set the name of a per-particle parameter. More...
int | addGlobalParameter (const std::string &name, double defaultValue)
| Add a new global parameter that the interaction may depend on. More...
const std::string & | getGlobalParameterName (int index) const
| Get the name of a global parameter. More...
void | setGlobalParameterName (int index, const std::string &name)
| Set the name of a global parameter. More...
double | getGlobalParameterDefaultValue (int index) const
| Get the default value of a global parameter. More...
void | setGlobalParameterDefaultValue (int index, double defaultValue)
| Set the default value of a global parameter. More...
int | addParticle (const std::vector< double > &parameters, int type=0)
| Add the nonbonded force parameters for a particle. More...
void | getParticleParameters (int index, std::vector< double > &parameters, int &type) const
| Get the nonbonded force parameters for a particle. More...
void | setParticleParameters (int index, const std::vector< double > &parameters, int type)
| Set the nonbonded force parameters for a particle. More...
int | addExclusion (int particle1, int particle2)
| Add a particle pair to the list of interactions that should be excluded. More...
void | getExclusionParticles (int index, int &particle1, int &particle2) const
| Get the particles in a pair whose interaction should be excluded. More...
void | setExclusionParticles (int index, int particle1, int particle2)
| Set the particles in a pair whose interaction should be excluded. More...
void | createExclusionsFromBonds (const std::vector< std::pair< int, int > > &bonds, int bondCutoff)
| Identify exclusions based on the molecular topology. More...
void | getTypeFilter (int index, std::set< int > &types) const
| Get the allowed particle types for one of the particles involved in the interaction. More...
void | setTypeFilter (int index, const std::set< int > &types)
| Set the allowed particle types for one of the particles involved in the interaction. More...
int | addTabulatedFunction (const std::string &name, TabulatedFunction *function)
| Add a tabulated function that may appear in the energy expression. More...
const TabulatedFunction & | getTabulatedFunction (int index) const
| Get a const reference to a tabulated function that may appear in the energy expression. More...
TabulatedFunction & | getTabulatedFunction (int index)
| Get a reference to a tabulated function that may appear in the energy expression. More...
const std::string & | getTabulatedFunctionName (int index) const
| Get the name of a tabulated function that may appear in the energy expression. More...
void | updateParametersInContext (Context &context)
| Update the per-particle parameters in a Context to match those stored in this Force object. More...
bool | usesPeriodicBoundaryConditions () const
| Returns whether or not this force makes use of periodic boundary conditions. More...
Public Member Functions inherited from Force
| Force ()
virtual | ~Force ()
int | getForceGroup () const
| Get the force group this Force belongs to. More...
void | setForceGroup (int group)
| Set the force group this Force belongs to. More...

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System. More...
Protected Member Functions inherited from Force
ForceImpl & | getImplInContext (Context &context)
| Get the ForceImpl corresponding to this Force in a Context. More...
ContextImpl & | getContextImpl (Context &context)
| Get the ContextImpl corresponding to a Context. More...

## Detailed Description

This class supports a wide variety of nonbonded N-particle interactions, where N is user specified.

The interaction energy is determined by an arbitrary, user specified algebraic expression that is evaluated for every possible set of N particles in the system. It may depend on the positions of the individual particles, the distances between pairs of particles, the angles formed by sets of three particles, and the dihedral angles formed by sets of four particles.

Be aware that the cost of evaluating an N-particle interaction increases very rapidly with N. Values larger than N=3 are rarely used.

We refer to a set of particles for which the energy is being evaluated as p1, p2, p3, etc. The energy expression may depend on the following variables and functions:

- x1, y1, z1, x2, y2, z2, etc.: The x, y, and z coordinates of the particle positions. For example, x1 is the x coordinate of particle p1, and y3 is the y coordinate of particle p3.
- distance(p1, p2): the distance between particles p1 and p2 (where "p1" and "p2" may be replaced by the names of whichever particles you want to calculate the distance between).
- angle(p1, p2, p3): the angle formed by the three specified particles.
- dihedral(p1, p2, p3, p4): the dihedral angle formed by the four specified particles.
- arbitrary global and per-particle parameters that you define.

To use this class, create a CustomManyParticleForce object, passing an algebraic expression to the constructor that defines the interaction energy of each set of particles. Then call addPerParticleParameter() to define per-particle parameters, and addGlobalParameter() to define global parameters. The values of per-particle parameters are specified as part of the system definition, while values of global parameters may be modified during a simulation by calling Context::setParameter().

Next, call addParticle() once for each particle in the System to set the values of its per-particle parameters. The number of particles for which you set parameters must be exactly equal to the number of particles in the System, or else an exception will be thrown when you try to create a Context. After a particle has been added, you can modify its parameters by calling setParticleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

Multi-particle interactions can be very expensive to evaluate, so they are usually used with a cutoff distance. The exact interpretation of the cutoff depends on the permutation mode, as discussed below.

CustomManyParticleForce also lets you specify "exclusions", particular pairs of particles whose interactions should be omitted from force and energy calculations. This is most often used for particles that are bonded to each other. If you specify a pair of particles as an exclusion, all sets that include those two particles will be omitted.

As an example, the following code creates a CustomManyParticleForce that implements an Axilrod-Teller potential. This is an interaction between three particles that depends on all three distances and angles formed by the particles.

``

    CustomManyParticleForce* force = new CustomManyParticleForce(3,
        "C*(1+3*cos(theta1)*cos(theta2)*cos(theta3))/(r12*r13*r23)^3;"
        "theta1=angle(p1,p2,p3); theta2=angle(p2,p3,p1); theta3=angle(p3,p1,p2);"
        "r12=distance(p1,p2); r13=distance(p1,p3); r23=distance(p2,p3)");
    force->setPermutationMode(CustomManyParticleForce::SinglePermutation);

This force depends on one parameter, C. The following code defines it as a global parameter:

``

    force->addGlobalParameter("C", 1.0);

Notice that the expression is symmetric with respect to the particles. It only depends on the products cos(theta1)*cos(theta2)*cos(theta3) and r12*r13*r23, both of which are unchanged if the labels p1, p2, and p3 are permuted. This is required because we specified SinglePermutation as the permutation mode. (This is the default, so we did not really need to set it, but doing so makes the example clearer.) In this mode, the expression is only evaluated once for each set of particles. No guarantee is made about which particle will be identified as p1, p2, etc. Therefore, the energy must be symmetric with respect to exchange of particles. Otherwise, the results would be undefined because permuting the labels would change the energy.

Not all many-particle interactions work this way. Another common pattern is for the expression to describe an interaction between one central particle and other nearby particles. An example of this is the 3-particle piece of the Stillinger-Weber potential:

``

    CustomManyParticleForce* force = new CustomManyParticleForce(3,
        "L*eps*(cos(theta1)+1/3)^2*exp(sigma*gamma/(r12-a*sigma))*exp(sigma*gamma/(r13-a*sigma));"
        "r12 = distance(p1,p2); r13 = distance(p1,p3); theta1 = angle(p3,p1,p2)");
    force->setPermutationMode(CustomManyParticleForce::UniqueCentralParticle);

When the permutation mode is set to UniqueCentralParticle, particle p1 is treated as the central particle. For a set of N particles, the expression is evaluated N times, once with each particle as p1. The expression can therefore treat p1 differently from the other particles. Notice that it is still symmetric with respect to p2 and p3, however. There is no guarantee about how those labels will be assigned to particles.

Distance cutoffs are applied in different ways depending on the permutation mode. In SinglePermutation mode, every particle in the set must be within the cutoff distance of every other particle. If any two particles are further apart than the cutoff distance, the interaction is skipped. In UniqueCentralParticle mode, each particle must be within the cutoff distance of the central particle, but not necessarily of all the other particles. The cutoff may therefore exclude a subset of the permutations of a set of particles.

Another common situation is that some particles are fundamentally different from others, causing the expression to be inherently non-symmetric. An example would be a water model that involves three particles, two of which must be hydrogen and one of which must be oxygen. Cases like this can be implemented using particle types.

A particle type is an integer that you specify when you call addParticle(). (If you omit the argument, it defaults to 0.) For the water model, you could specify 0 for all oxygen atoms and 1 for all hydrogen atoms. You can then call setTypeFilter() to specify the list of allowed types for each of the N particles involved in an interaction:

``

    set<int> oxygenTypes, hydrogenTypes;
    oxygenTypes.insert(0);
    hydrogenTypes.insert(1);
    force->setTypeFilter(0, oxygenTypes);
    force->setTypeFilter(1, hydrogenTypes);
    force->setTypeFilter(2, hydrogenTypes);

This specifies that of the three particles in an interaction, p1 must be oxygen while p2 and p3 must be hydrogen. The energy expression will only be evaluated for triplets of particles that satisfy those requirements. It will still only be evaluated once for each triplet, so it must still be symmetric with respect to p2 and p3.

Expressions may involve the operators + (add), - (subtract), * (multiply), / (divide), and ^ (power), and the following functions: sqrt, exp, log, sin, cos, sec, csc, tan, cot, asin, acos, atan, sinh, cosh, tanh, erf, erfc, min, max, abs, floor, ceil, step, delta, select. All trigonometric functions are defined in radians, and log is the natural logarithm. step(x) = 0 if x is less than 0, 1 otherwise. delta(x) = 1 if x is 0, 0 otherwise. select(x,y,z) = z if x = 0, y otherwise. The names of per-particle parameters have the suffix "1", "2", etc. appended to them to indicate the values for the multiple interacting particles. For example, if you define a per-particle parameter called "charge", then the variable "charge2" is the charge of particle p2. As seen above, the expression may also involve intermediate quantities that are defined following the main expression, using ";" as a separator.

In addition, you can call addTabulatedFunction() to define a new function based on tabulated values. You specify the function by creating a TabulatedFunction object. That function can then appear in the expression.

## Member Enumeration Documentation

enum NonbondedMethod

This is an enumeration of the different methods that may be used for handling long range nonbonded forces.

Enumerator
NoCutoff | No cutoff is applied to nonbonded interactions. The full set of interactions is computed exactly. This necessarily means that periodic boundary conditions cannot be used. This is the default.
CutoffNonPeriodic | Interactions are ignored if any two particles are further apart than the cutoff distance.
CutoffPeriodic | Periodic boundary conditions are used, so that each particle interacts only with the nearest periodic copy of each other particle. Interactions are ignored if any two particles are further apart than the cutoff distance.

enum PermutationMode

This is an enumeration of the different modes for selecting which permutations of a set of particles to evaluate the interaction for.

Enumerator
SinglePermutation | For any set of particles, the interaction is evaluated only once for a single permutation of the particles. There is no guarantee about which permutation will be used (aside from the requirement to satisfy type filters), so the expression must be symmetric. If cutoffs are used, then every particle in the set must be within the cutoff distance of every other particle.

UniqueCentralParticle

The interaction is treated as an interaction between one central particle (p1) and various other nearby particles (p2, p3, ...).

For a set of N particles it will be evaluated N times, once with each particle as p1. The expression must be symmetric with respect to the other particles, but may treat p1 differently. If cutoffs are used, then every particle must be within the cutoff distance of p1.

## Constructor & Destructor Documentation

CustomManyParticleForce | ( | int | particlesPerSet,
|  | const std::string & | energy
| ) |  |

explicit

Create a CustomManyParticleForce.

Parameters

  particlesPerSet | the number of particles in each set for which the energy is evaluated
  energy | an algebraic expression giving the interaction energy of each triplet as a function of particle positions, inter-particle distances, angles, and any global and per-particle parameters

~CustomManyParticleForce | ( |  | ) |

## Member Function Documentation

int addExclusion | ( | int | particle1,
|  | int | particle2
| ) |  |

Add a particle pair to the list of interactions that should be excluded.

In many cases, you can use createExclusionsFromBonds() rather than adding each exclusion explicitly.

Parameters

  particle1 | the index of the first particle in the pair
  particle2 | the index of the second particle in the pair

Returns
  the index of the exclusion that was added

int addGlobalParameter | ( | const std::string & | name,
|  | double | defaultValue
| ) |  |

Add a new global parameter that the interaction may depend on.

Parameters

  name | the name of the parameter
  defaultValue | the default value of the parameter

Returns
  the index of the parameter that was added

int addParticle | ( | const std::vector< double > & | parameters,
|  | int | type = `0`
| ) |  |

Add the nonbonded force parameters for a particle.

This should be called once for each particle in the System. When it is called for the i'th time, it specifies the parameters for the i'th particle.

Parameters

  parameters | the list of parameters for the new particle
  type | the type of the new particle

Returns
  the index of the particle that was added

int addPerParticleParameter | ( | const std::string & | name | ) |

Add a new per-particle parameter that the interaction may depend on.

Parameters

  name | the name of the parameter

Returns
  the index of the parameter that was added

int addTabulatedFunction | ( | const std::string & | name,
|  | TabulatedFunction * | function
| ) |  |

Add a tabulated function that may appear in the energy expression.

Parameters

  name | the name of the function as it appears in expressions
  function | a TabulatedFunction object defining the function. The TabulatedFunction should have been created on the heap with the "new" operator. The Force takes over ownership of it, and deletes it when the Force itself is deleted.

Returns
  the index of the function that was added

void createExclusionsFromBonds | ( | const std::vector< std::pair< int, int > > & | bonds,
|  | int | bondCutoff
| ) |  |

Identify exclusions based on the molecular topology.

Particles which are separated by up to a specified number of bonds are added as exclusions.

Parameters

  bonds | the set of bonds based on which to construct exclusions. Each element specifies the indices of two particles that are bonded to each other.
  bondCutoff | pairs of particles that are separated by this many bonds or fewer are added to the list of exclusions

ForceImpl* createImpl | ( |  | ) | const

protectedvirtual

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

double getCutoffDistance | ( |  | ) | const

Get the cutoff distance (in nm) being used for nonbonded interactions.

If the NonbondedMethod in use is NoCutoff, this value will have no effect.

Returns
  the cutoff distance, measured in nm

const std::string& getEnergyFunction | ( |  | ) | const

Get the algebraic expression that gives the interaction energy of each bond.

void getExclusionParticles | ( | int | index,
|  | int & | particle1,
|  | int & | particle2
| ) |  | const

Get the particles in a pair whose interaction should be excluded.

Parameters

  index | the index of the exclusion for which to get particle indices
  particle1 | the index of the first particle in the pair
  particle2 | the index of the second particle in the pair

double getGlobalParameterDefaultValue | ( | int | index | ) | const

Get the default value of a global parameter.

Parameters

  index | the index of the parameter for which to get the default value

Returns
  the parameter default value

const std::string& getGlobalParameterName | ( | int | index | ) | const

Get the name of a global parameter.

Parameters

  index | the index of the parameter for which to get the name

Returns
  the parameter name

NonbondedMethod getNonbondedMethod | ( |  | ) | const

Get the method used for handling long range nonbonded interactions.

int getNumExclusions | ( |  | ) | const

inline

Get the number of particle pairs whose interactions should be excluded.

int getNumGlobalParameters | ( |  | ) | const

inline

Get the number of global parameters that the interaction depends on.

int getNumParticles | ( |  | ) | const

inline

Get the number of particles for which force field parameters have been defined.

int getNumParticlesPerSet | ( |  | ) | const

inline

Get the number of particles in each set for which the energy is evaluated.

int getNumPerParticleParameters | ( |  | ) | const

inline

Get the number of per-particle parameters that the interaction depends on.

int getNumTabulatedFunctions | ( |  | ) | const

inline

Get the number of tabulated functions that have been defined.

void getParticleParameters | ( | int | index,
|  | std::vector< double > & | parameters,
|  | int & | type
| ) |  | const

Get the nonbonded force parameters for a particle.

Parameters

  index | the index of the particle for which to get parameters
  parameters | the list of parameters for the specified particle
  type | the type of the specified particle

PermutationMode getPermutationMode | ( |  | ) | const

Get the mode that selects which permutations of a set of particles to evaluate the interaction for.

const std::string& getPerParticleParameterName | ( | int | index | ) | const

Get the name of a per-particle parameter.

Parameters

  index | the index of the parameter for which to get the name

Returns
  the parameter name

const TabulatedFunction& getTabulatedFunction | ( | int | index | ) | const

Get a const reference to a tabulated function that may appear in the energy expression.

Parameters

  index | the index of the function to get

Returns
  the TabulatedFunction object defining the function

TabulatedFunction& getTabulatedFunction | ( | int | index | ) |

Get a reference to a tabulated function that may appear in the energy expression.

Parameters

  index | the index of the function to get

Returns
  the TabulatedFunction object defining the function

const std::string& getTabulatedFunctionName | ( | int | index | ) | const

Get the name of a tabulated function that may appear in the energy expression.

Parameters

  index | the index of the function to get

Returns
  the name of the function as it appears in expressions

void getTypeFilter | ( | int | index,
|  | std::set< int > & | types
| ) |  | const

Get the allowed particle types for one of the particles involved in the interaction.

If this an empty set (the default), no filter is applied and all interactions are evaluated regardless of the type of the specified particle.

Parameters

  index | the index of the particle within the interaction (between 0 and getNumParticlesPerSet())
  types | the allowed types for the specified particle

void setCutoffDistance | ( | double | distance | ) |

Set the cutoff distance (in nm) being used for nonbonded interactions.

If the NonbondedMethod in use is NoCutoff, this value will have no effect.

Parameters

  distance | the cutoff distance, measured in nm

void setEnergyFunction | ( | const std::string & | energy | ) |

Set the algebraic expression that gives the interaction energy of each bond.

void setExclusionParticles | ( | int | index,
|  | int | particle1,
|  | int | particle2
| ) |  |

Set the particles in a pair whose interaction should be excluded.

Parameters

  index | the index of the exclusion for which to set particle indices
  particle1 | the index of the first particle in the pair
  particle2 | the index of the second particle in the pair

void setGlobalParameterDefaultValue | ( | int | index,
|  | double | defaultValue
| ) |  |

Set the default value of a global parameter.

Parameters

  index | the index of the parameter for which to set the default value
  name | the default value of the parameter

void setGlobalParameterName | ( | int | index,
|  | const std::string & | name
| ) |  |

Set the name of a global parameter.

Parameters

  index | the index of the parameter for which to set the name
  name | the name of the parameter

void setNonbondedMethod | ( | NonbondedMethod | method | ) |

Set the method used for handling long range nonbonded interactions.

void setParticleParameters | ( | int | index,
|  | const std::vector< double > & | parameters,
|  | int | type
| ) |  |

Set the nonbonded force parameters for a particle.

Parameters

  index | the index of the particle for which to set parameters
  parameters | the list of parameters for the specified particle
  type | the type of the specified particle

void setPermutationMode | ( | PermutationMode | mode | ) |

Set the mode that selects which permutations of a set of particles to evaluate the interaction for.

void setPerParticleParameterName | ( | int | index,
|  | const std::string & | name
| ) |  |

Set the name of a per-particle parameter.

Parameters

  index | the index of the parameter for which to set the name
  name | the name of the parameter

void setTypeFilter | ( | int | index,
|  | const std::set< int > & | types
| ) |  |

Set the allowed particle types for one of the particles involved in the interaction.

If this an empty set (the default), no filter is applied and all interactions are evaluated regardless of the type of the specified particle.

Parameters

  index | the index of the particle within the interaction (between 0 and getNumParticlesPerSet())
  types | the allowed types for the specified particle

void updateParametersInContext | ( | Context & | context | ) |

Update the per-particle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setParticleParameters() to modify this object's parameters, then call updateParametersInContext() to copy them over to the Context.

This method has several limitations. The only information it updates is the values of per-particle parameters. All other aspects of the Force (the energy function, nonbonded method, cutoff distance, etc.) are unaffected and can only be changed by reinitializing the Context. Also, this method cannot be used to add new particles, only to change the parameters of existing ones.

bool usesPeriodicBoundaryConditions | ( |  | ) | const

inlinevirtual

Returns whether or not this force makes use of periodic boundary conditions.

Returns
  true if force uses PBC and false otherwise

Reimplemented from Force.

References CustomManyParticleForce::CutoffPeriodic.

The documentation for this class was generated from the following file:

- CustomManyParticleForce.h